#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUF_SIZE 1024

char **carica_parole(FILE *file);
int conta_errori(char **parole);

int main() {
  char file[128];
  scanf("%s", file);
  FILE *fin = fopen(file, "r");
  if (!fin) {
    printf("Errore di apertura del file\n");
    return 0;
  }
  char **p = carica_parole(fin);
  fclose(fin);
  if (p != NULL) {
    for (int i = 0; p[i] != NULL; i++) {
      printf("%s\n", p[i]);
      //free(p[i]); WTF
    }
    printf("Errori rilevati: %d\n", conta_errori(p));
    free(p);
  }
  return 0;
}


char **carica_parole(FILE *file) {
  int cnt = 0;
  int curr;
  char buf[BUF_SIZE];
  char tmp;
  char **res;

  curr = fscanf(file, "%[a-zA-Z0-9]", buf);
  while (curr != EOF) {
    if (curr == 1) {
      cnt++;
    }
    else {
      fscanf(file, "%1c", &tmp);
    }
    curr = fscanf(file, "%[a-zA-Z0-9]", buf);
  }

  rewind(file);

  res = malloc(sizeof(char*) * (cnt+1));

  cnt=0;
  curr = fscanf(file, "%[a-zA-Z0-9]", buf);
  while (curr != EOF) {
    if (curr == 1) {
      res[cnt] = malloc(sizeof(char) * (strlen(buf) + 1));
      strcpy(res[cnt], buf);
      cnt++;
    }
    else {
      fscanf(file, "%1c", &tmp);
    }
    curr = fscanf(file, "%[a-zA-Z0-9]", buf);
  }

  res[cnt] = NULL;
  return res;
}


char **carica_parole_alternativo(FILE *file) {
  int num_parole = 0;
  int cnt = 0;
  int i;
  int in_parola = 0;
  char curr = fgetc(file);
  char **res; 

  // count the number of words
  while (!feof(file)) {
    if ((curr >= '0' && curr <= '9') ||
        (curr >= 'a' && curr <= 'z') ||
        (curr >= 'A' && curr <= 'Z')) {
      if (!in_parola) {
        num_parole++;
        in_parola = 1;
      }
    }
    else {
      in_parola = 0;
    }
    curr = fgetc(file);
  }

  // compute the length of each word
  res = malloc(sizeof(char*) * (num_parole+1));

  rewind(file);
  curr = fgetc(file);
  cnt = 0;
  i=0;
  while (!feof(file)) {
    if ((curr >= '0' && curr <= '9') ||
        (curr >= 'a' && curr <= 'z') ||
        (curr >= 'A' && curr <= 'Z')) {
      in_parola = 1;
      cnt++;
    }
    else {
      if (in_parola) {
        res[i] = malloc(sizeof(char) * (cnt+1));
        i++;
        cnt = 0;
      }
      in_parola = 0;
    }
    curr = fgetc(file);
  }

  if (i != num_parole) {
    res[i] = malloc(sizeof(char) * (cnt+1));
  }

  // copy the words into the resulting array
  rewind(file);
  curr = fgetc(file);
  cnt = 0;
  i=0;
  while (!feof(file)) {
    if ((curr >= '0' && curr <= '9') ||
        (curr >= 'a' && curr <= 'z') ||
        (curr >= 'A' && curr <= 'Z')) {
      in_parola = 1;
      res[i][cnt] = curr;
      cnt++;
    }
    else {
      if (in_parola) {
        res[i][cnt+1] = '\0';
        i++;
        cnt = 0;
      }
      in_parola = 0;
    }
    curr = fgetc(file);
  }
  res[i+1] = NULL;
  return res;
}

int conta_errori(char **parole) {
  char* elem = parole[0];
  int leggendo_num;
  int res=0;
  int j=0;

  while (elem != NULL)
  {
    leggendo_num = elem[0] >= '0' && elem[0] <= '9';
    for (int i=0; i<strlen(elem); i++){
      if(leggendo_num && !(elem[i] >= '0' && elem[i] <= '9'))
      {
        res++; break;
      }
    }
    j++;
    elem = parole[j];
  }
  return res;
}