#include <stdio.h>

#define TENTATIVI 6
#define LUNGHEZZA 5

char gioco[TENTATIVI][LUNGHEZZA] =
{
  {'P','I','Z','Z','A'},
  {'R','E','A','L','E'},
  {'R','U','O','T','A'},
  {'F','O','R','M','A'},
  {'F','O','R','Z','A'},
  {'\0','\0','\0','\0','\0'}
};

int contiene(char* str, char c, int l) {
  if (c == '\0' || str[0] == '\0') {
    return -1;
  }

  for (int i=0; i<l; i++) {
    if (c == str[i]) {
      return 1;
    }
  }
  return 0;
}

int controlla_partita(char partita[TENTATIVI][LUNGHEZZA], int colori[TENTATIVI][LUNGHEZZA], char parola[LUNGHEZZA]) {
  int res = 0;
  char curr;
  int giallo;
  int corrette;

  for (int i=0; i<TENTATIVI; i++) {
    corrette = 0;
    for (int j=0; j<LUNGHEZZA; j++) {
      curr = partita[i][j];
      giallo = contiene(parola, curr, LUNGHEZZA);

      if (curr == parola[j]) {
        colori[i][j] = 1;
        corrette++;
      }
      else if (giallo == 1) {
        colori[i][j] = 2;
      }
      else if (giallo == 0) {
        colori[i][j] = 3;
      }
      else {
        colori[i][j] = 0;
      }

      if (corrette == LUNGHEZZA) {
        res = 1;
      }
    }
  }
  return res;
} 

int main() {
  int colori[TENTATIVI][LUNGHEZZA] = {0};

  int vinta = controlla_partita(gioco, colori, "FORZA");

  for (int i=0; i<TENTATIVI; i++) {
    for (int j=0; j<LUNGHEZZA; j++) {
      printf("%d ", colori[i][j]);
    }
    printf("\n");
  }

  if (vinta) {
    printf("YOU WIN!\n");
  }
  else {
    printf("You lose :(\n");
  }
}