#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LUNG 128

typedef struct {
  char nome[LUNG];
  float media;
} media_t;

typedef struct {
  media_t media;
  int eta;
} studente_t;

void aggiungi_media(media_t nuova, media_t *medie, int len) {
  media_t tmp1, tmp2;
  for (int i=0; i<len; i++) {
    if (nuova.media > medie[i].media) {
      // inserisci l'elemento nella lista
      memcpy(&tmp1, &nuova, sizeof(media_t)); 
      for (int j=i; j<len; j++) {
        memcpy(&tmp2, &medie[j], sizeof(media_t));
        memcpy(&medie[j], &tmp1, sizeof(media_t));
        memcpy(&tmp1, &tmp2, sizeof(media_t));
      }
      return;
    }
  }
}

void aggiungi_media_alt(media_t nuova, media_t *medie, int len) {
  int min_idx = 0;

  for (int i=1; i<len; i++) {
    if (medie[i].media < medie[min_idx].media) {
      min_idx = i;
    }
  }

  if (medie[min_idx].media < nuova.media) {
    memcpy(&medie[min_idx], &nuova, sizeof(media_t));
  }
}

media_t *miglioriNStudenti(char* filename, int num_scelti, int eta_massima) {
  FILE *file = fopen(filename, "r");
  media_t *medie = malloc(sizeof(media_t) * num_scelti);
  studente_t tmp;

  if (!file) {
    perror("Impossibile aprire il file\n");
    exit(-1);
  }

  while (fscanf(file, "%s %d %f", tmp.media.nome, &tmp.eta, &tmp.media.media) != EOF) {
    if (tmp.eta < eta_massima) {
      aggiungi_media_alt(tmp.media, medie, num_scelti);
    }
  }

  return medie;
}

int main() {
  int num_scelti = 4;
  int eta_massima = 25;
  media_t *medie = miglioriNStudenti("files/es7.txt", num_scelti, eta_massima);
  for (int i=0; i<num_scelti; i++) {
    printf("%s %f\n", medie[i].nome, medie[i].media);
  }
}